diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerWorkbench.java b/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
similarity index 52%
rename from src/main/java/net/minecraft/core/player/inventory/ContainerWorkbench.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
index 2b6119f2f..9041c2412 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerWorkbench.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
@@ -1,38 +1,48 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.menu;
 
 // Referenced classes of package net.minecraft.src:
 //            Container, InventoryCrafting, InventoryCraftResult, SlotCrafting, 
 //            InventoryPlayer, Slot, CraftingManager, IInventory, 
-//            World, EntityPlayer, Block, ItemStack
+//            World, Player, Block, ItemStack
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.container.ResultContainer;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotCrafting;
+import net.minecraft.core.player.inventory.slot.ResultSlot;
 import net.minecraft.core.world.World;
 
 import java.util.List;
 
-public class ContainerWorkbench extends Container
+public class CraftingMenu extends AbstractContainerMenu
 {
+	public CraftingContainer craftSlots;
+	public Container resultSlots;
+	private World world;
+	private int x;
+	private int y;
+	private int z;
 
-    public ContainerWorkbench(InventoryPlayer inventoryplayer, World world, int i, int j, int k)
+    public CraftingMenu(Inventory inventory, World world, int x, int y, int z)
     {
-        craftMatrix = new InventoryCrafting(this, 3, 3);
-        craftResult = new InventoryCraftResult();
-        field_20133_c = world;
-        field_20132_h = i;
-        field_20131_i = j;
-        field_20130_j = k;
-        addSlot(new SlotCrafting(inventoryplayer.player, craftMatrix, craftResult, 0, 124, 35));
+        craftSlots = new CraftingContainer(this, 3, 3);
+        resultSlots = new ResultContainer();
+        this.world = world;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        addSlot(new ResultSlot(inventory.player, craftSlots, resultSlots, 0, 124, 35));
         for(int l = 0; l < 3; l++)
         {
             for(int k1 = 0; k1 < 3; k1++)
             {
-                addSlot(new Slot(craftMatrix, k1 + l * 3, 30 + k1 * 18, 17 + l * 18));
+                addSlot(new Slot(craftSlots, k1 + l * 3, 30 + k1 * 18, 17 + l * 18));
             }
 
         }
@@ -41,31 +51,31 @@ public class ContainerWorkbench extends Container
         {
             for(int l1 = 0; l1 < 9; l1++)
             {
-                addSlot(new Slot(inventoryplayer, l1 + i1 * 9 + 9, 8 + l1 * 18, 84 + i1 * 18));
+                addSlot(new Slot(inventory, l1 + i1 * 9 + 9, 8 + l1 * 18, 84 + i1 * 18));
             }
 
         }
 
         for(int j1 = 0; j1 < 9; j1++)
         {
-            addSlot(new Slot(inventoryplayer, j1, 8 + j1 * 18, 142));
+            addSlot(new Slot(inventory, j1, 8 + j1 * 18, 142));
         }
 
-        onCraftMatrixChanged(craftMatrix);
+        slotsChanged(craftSlots);
     }
 
     @Override
-	public void onCraftMatrixChanged(IInventory iinventory)
+	public void slotsChanged(Container iinventory)
     {
-		craftResult.setInventorySlotContents(0, Registries.RECIPES.findMatchingRecipe(craftMatrix));
+		resultSlots.setItem(0, Registries.RECIPES.findMatchingRecipe(craftSlots));
     }
 
 	@Override
-	public void onCraftGuiClosed(EntityPlayer player) {
+	public void onCraftGuiClosed(Player player) {
 		super.onCraftGuiClosed(player);
 		boolean insert = false;
 		for (int i = 0; i < 9; i++) {
-			ItemStack itemstack = craftMatrix.getStackInSlot(i);
+			ItemStack itemstack = craftSlots.getItem(i);
 			if(itemstack != null) {
 				storeOrDropItem(player, itemstack);
 				insert = true;
@@ -77,13 +87,13 @@ public class ContainerWorkbench extends Container
 	}
 
     @Override
-	public boolean isUsableByPlayer(EntityPlayer entityplayer)
+	public boolean stillValid(Player entityplayer)
     {
-        if(field_20133_c.getBlockId(field_20132_h, field_20131_i, field_20130_j) != Block.workbench.id)
+        if(world.getBlockId(x, y, z) != Blocks.WORKBENCH.id)
         {
             return false;
         }
-        return entityplayer.distanceToSqr((double)field_20132_h + 0.5D, (double)field_20131_i + 0.5D, (double)field_20130_j + 0.5D) <= 64D;
+        return entityplayer.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
     }
     
     /*
@@ -94,26 +104,26 @@ public class ContainerWorkbench extends Container
      */
     
     @Override
-    public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-    	if(slot.id == 0) {
+    public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+    	if(slot.index == 0) {
     		// Craft Result
     		return getSlots(0, 1, false);
     	}
-    	if(slot.id >= 1 && slot.id < 9) {
+    	if(slot.index >= 1 && slot.index < 9) {
     		// Crafting Grid
     		return getSlots(1, 9, false);
     	}
     	if(action == InventoryAction.MOVE_SIMILAR) {
-    		if(slot.id >= 10 && slot.id <= 45) {
+    		if(slot.index >= 10 && slot.index <= 45) {
     			// Full Inventory
     			return getSlots(10, 36, false);
     		}
     	}else {
-    		if(slot.id >= 10 && slot.id <= 36) {
+    		if(slot.index >= 10 && slot.index <= 36) {
     			// Main Inventory
     			return getSlots(10, 27, false);
     		}
-    		if(slot.id >= 37 && slot.id <= 45) {
+    		if(slot.index >= 37 && slot.index <= 45) {
     			// Hotbar
     			return getSlots(37, 9, false);
     		}
@@ -122,23 +132,23 @@ public class ContainerWorkbench extends Container
     }
     
     @Override
-    public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-    	if(slot.id >= 10 && slot.id <= 45) {
+    public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+    	if(slot.index >= 10 && slot.index <= 45) {
     		// Full Inventory
     		if(target == 1) {
     			return getSlots(1, 9, false); // To Crafting Grid
     		}
-    		if(slot.id >= 10 && slot.id <= 36) {
+    		if(slot.index >= 10 && slot.index <= 36) {
     			// Main Inventory
     			return getSlots(37, 9, false); // To Hotbar
     		}
-    		if(slot.id >= 37 && slot.id <= 45) {
+    		if(slot.index >= 37 && slot.index <= 45) {
     			// Hotbar
     			return getSlots(10, 27, false); // To Main Inventory
     		}
     	}else {
     		// Crafting grid or result
-    		if(slot.id == 0) {
+    		if(slot.index == 0) {
     			// Crafting Result
     			return getSlots(10, 36, true);
     		}else {
@@ -149,11 +159,4 @@ public class ContainerWorkbench extends Container
     	
     	return null;
     }
-    
-    public InventoryCrafting craftMatrix;
-    public IInventory craftResult;
-    private World field_20133_c;
-    private int field_20132_h;
-    private int field_20131_i;
-    private int field_20130_j;
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java b/src/main/java/net/minecraft/core/player/inventory/menu/CreativeInventoryMenu.java
similarity index 70%
rename from src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/CreativeInventoryMenu.java
index 7848bdbdb..b07072708 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/CreativeInventoryMenu.java
@@ -1,17 +1,20 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.menu;
 
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.player.inventory.slot.SlotCreative;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.slot.CreativeSlot;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class ContainerPlayerCreative extends ContainerPlayer
+public class CreativeInventoryMenu extends InventoryMenu
 {
 	public int page = 0;
 	public int maxPage;
@@ -19,16 +22,16 @@ public class ContainerPlayerCreative extends ContainerPlayer
 	protected List<ItemStack> searchedItems = new ArrayList<ItemStack>();
 	public String searchText = "";
 	
-	public ContainerPlayerCreative(InventoryPlayer inventoryplayer)
+	public CreativeInventoryMenu(Inventory inventoryplayer)
 	{
 		this(inventoryplayer, true);
 	}
 	
-	public ContainerPlayerCreative(InventoryPlayer inventoryplayer, boolean isNotClientSide)
+	public CreativeInventoryMenu(Inventory inventoryplayer, boolean isNotClientSide)
 	{
 		super(inventoryplayer, isNotClientSide);
 		
-		creativeSlotsStart = this.inventorySlots.size();
+		creativeSlotsStart = this.slots.size();
 		
 		// Add creative slots
 		for (int i = 0; i < 36; i++)
@@ -36,7 +39,7 @@ public class ContainerPlayerCreative extends ContainerPlayer
 			int x = i % 6;
 			int y = i / 6;
 			
-			addSlot(new SlotCreative(creativeSlotsStart + i, 184 + (x * 18), 30 + (y * 18), creativeItems.get(i)));
+			addSlot(new CreativeSlot(creativeSlotsStart + i, 184 + (x * 18), 30 + (y * 18), creativeItems.get(i)));
 		}
 		
 		searchPage("");
@@ -100,15 +103,15 @@ public class ContainerPlayerCreative extends ContainerPlayer
 		{
 			if (i + (page * 36) >= searchedItems.size())
 			{
-				((SlotCreative)this.inventorySlots.get(creativeSlotsStart + i)).item = null;
+				((CreativeSlot)this.slots.get(creativeSlotsStart + i)).item = null;
 			}
 			else
 			{
-				((SlotCreative)this.inventorySlots.get(creativeSlotsStart + i)).item = searchedItems.get(i + (page * 36));				
+				((CreativeSlot)this.slots.get(creativeSlotsStart + i)).item = searchedItems.get(i + (page * 36));
 			}			
 		}
 		
-		playerInv.player.updateCreativeInventory(page, searchText);
+		inventory.player.updateCreativeInventory(page, searchText);
 	}
 
 	public String getSearchText(){
@@ -134,7 +137,7 @@ public class ContainerPlayerCreative extends ContainerPlayer
 				creativeItems.add(new ItemStack(Block.blocksList[id]));
 				count++;
 				
-				if (id == Block.wool.id || id == Block.planksOakPainted.id || id == Block.lampIdle.id || id == Block.fencePlanksOakPainted.id)
+				if (id == Blocks.WOOL.id || id == Blocks.PLANKS_OAK_PAINTED.id || id == Blocks.LAMP_IDLE.id || id == Blocks.FENCE_PLANKS_OAK_PAINTED.id)
 				{
 					for (int i = 1; i < 16; i++)
 					{
@@ -142,9 +145,9 @@ public class ContainerPlayerCreative extends ContainerPlayer
 						count++;
 					}
 				}
-				else if (id == Block.chestPlanksOakPainted.id || id == Block.slabPlanksOakPainted.id || id == Block.fencegatePlanksOakPainted.id
-					  || id == Block.stairsPlanksOakPainted.id || id == Block.doorPlanksOakPaintedBottom.id || id == Block.doorPlanksOakPaintedTop.id
-					  || id == Block.trapdoorPlanksOakPainted.id)
+				else if (id == Blocks.CHEST_PLANKS_OAK_PAINTED.id || id == Blocks.SLAB_PLANKS_PAINTED.id || id == Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id
+					  || id == Blocks.STAIRS_PLANKS_PAINTED.id || id == Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id || id == Blocks.DOOR_PLANKS_PAINTED_TOP.id
+					  || id == Blocks.TRAPDOOR_PLANKS_PAINTED.id)
 				{
 					for (int i = 0x10; i < 0x100; i += 0x10)
 					{
@@ -162,7 +165,7 @@ public class ContainerPlayerCreative extends ContainerPlayer
 				creativeItems.add(new ItemStack(Item.itemsList[i]));
 				count++;
 
-				if (i == Item.coal.id)
+				if (i == Items.COAL.id)
 				{
 					for (int j = 1; j < 2; j++)
 					{
@@ -171,7 +174,7 @@ public class ContainerPlayerCreative extends ContainerPlayer
 					}
 				}
 
-				if (i == Item.dye.id || i == Item.doorOakPainted.id)
+				if (i == Items.DYE.id || i == Items.DOOR_OAK_PAINTED.id)
 				{
 					for (int j = 1; j < 16; j++)
 					{
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerFlag.java b/src/main/java/net/minecraft/core/player/inventory/menu/FlagMenu.java
similarity index 56%
rename from src/main/java/net/minecraft/core/player/inventory/ContainerFlag.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/FlagMenu.java
index a3ca971a2..c30009e30 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerFlag.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/FlagMenu.java
@@ -1,75 +1,76 @@
-package net.minecraft.core.player.inventory;
-
-import java.util.List;
-
-import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotDye;
-
-public class ContainerFlag extends Container {
-	public TileEntityFlag tileEntity;
-
-	public ContainerFlag(IInventory inv, TileEntityFlag flag) {
-		this.tileEntity = flag;
-
-		// Dye slots
-		addSlot(new SlotDye(flag, 36, 129, 10));
-		addSlot(new SlotDye(flag, 37, 129, 32));
-		addSlot(new SlotDye(flag, 38, 129, 54));
-
-		// Player inv slots
-		for (int y = 0; y < 3; y++) {
-			for (int x = 0; x < 9; x++) {
-				addSlot(new Slot(inv, x + y * 9 + 9, 8 + x * 18, 113 + y * 18));
-			}
-		}
-
-		// Player hotbar
-		for (int i = 0; i < 9; i++) {
-			addSlot(new Slot(inv, i, 8 + i * 18, 171));
-		}
-	}
-
-	/*
-	 *   0 -   2 Dye Slots
-	 *   3 -  29 Inventory
-	 *  30 -  38 Hotbar
-	 */
-	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id >= 0 && slot.id <= 2) {
-			// Dye Slots
-			return getSlots(0, 3, false);
-		}
-		if(action == InventoryAction.MOVE_SIMILAR) {
-			// Full Inventory
-			return getSlots(3, 36, false);
-		}
-		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.id < 27) {
-				// Main Inventory
-				return getSlots(3, 27, false);
-			}else {
-				// Hotbar
-				return getSlots(30, 9, false);
-			}
-		}
-		return null;
-	}
-
-	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id >= 0 && slot.id <= 2) {
-			// Dye Slots
-			return getSlots(3, 36, false); // Into Inventory
-		}
-		return getSlots(0, 3, false); // Dye Slots
-	}
-
-	@Override
-	public boolean isUsableByPlayer(EntityPlayer entityplayer) {
-		return tileEntity.canInteractWith(entityplayer);
-	}
-}
+package net.minecraft.core.player.inventory.menu;
+
+import java.util.List;
+
+import net.minecraft.core.InventoryAction;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.player.inventory.slot.DyeSlot;
+
+public class FlagMenu extends AbstractContainerMenu {
+	public FlagBlockEntity flag;
+
+	public FlagMenu(Container inv, FlagBlockEntity flag) {
+		this.flag = flag;
+
+		// Dye slots
+		addSlot(new DyeSlot(flag, 36, 129, 10));
+		addSlot(new DyeSlot(flag, 37, 129, 32));
+		addSlot(new DyeSlot(flag, 38, 129, 54));
+
+		// Player inv slots
+		for (int y = 0; y < 3; y++) {
+			for (int x = 0; x < 9; x++) {
+				addSlot(new Slot(inv, x + y * 9 + 9, 8 + x * 18, 113 + y * 18));
+			}
+		}
+
+		// Player hotbar
+		for (int i = 0; i < 9; i++) {
+			addSlot(new Slot(inv, i, 8 + i * 18, 171));
+		}
+	}
+
+	/*
+	 *   0 -   2 Dye Slots
+	 *   3 -  29 Inventory
+	 *  30 -  38 Hotbar
+	 */
+	@Override
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= 0 && slot.index <= 2) {
+			// Dye Slots
+			return getSlots(0, 3, false);
+		}
+		if(action == InventoryAction.MOVE_SIMILAR) {
+			// Full Inventory
+			return getSlots(3, 36, false);
+		}
+		if(action == InventoryAction.MOVE_ALL) {
+			if(slot.index < 27) {
+				// Main Inventory
+				return getSlots(3, 27, false);
+			}else {
+				// Hotbar
+				return getSlots(30, 9, false);
+			}
+		}
+		return null;
+	}
+
+	@Override
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= 0 && slot.index <= 2) {
+			// Dye Slots
+			return getSlots(3, 36, false); // Into Inventory
+		}
+		return getSlots(0, 3, false); // Dye Slots
+	}
+
+	@Override
+	public boolean stillValid(Player entityplayer) {
+		return flag.stillValid(entityplayer);
+	}
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/FurnaceMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/FurnaceMenu.java
new file mode 100644
index 000000000..22bb60279
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/FurnaceMenu.java
@@ -0,0 +1,150 @@
+package net.minecraft.core.player.inventory.menu;
+
+import java.util.List;
+
+import net.minecraft.core.InventoryAction;
+import net.minecraft.core.block.entity.FurnaceBlockEntity;
+import net.minecraft.core.crafting.ContainerListener;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.player.inventory.slot.FurnaceSlot;
+
+public class FurnaceMenu extends AbstractContainerMenu {
+
+	public FurnaceBlockEntity furnace;
+	private int currentCookTime;
+	private int currentBurnTime;
+	private int itemBurnTime;
+	private int itemCookTime;
+
+	public FurnaceMenu(Inventory inventoryplayer, FurnaceBlockEntity tileentityfurnace) {
+		currentCookTime = 0;
+		currentBurnTime = 0;
+		itemCookTime = 0;
+		itemBurnTime = 0;
+		furnace = tileentityfurnace;
+		addSlot(new Slot(tileentityfurnace, 0, 56, 17));
+		addSlot(new Slot(tileentityfurnace, 1, 56, 53));
+		addSlot(new FurnaceSlot(inventoryplayer.player, tileentityfurnace, 2, 116, 35));
+		for (int i = 0; i < 3; i++) {
+			for (int k = 0; k < 9; k++) {
+				addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
+			}
+
+		}
+
+		for (int j = 0; j < 9; j++) {
+			addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 142));
+		}
+
+	}
+
+	@Override
+	public void broadcastChanges() {
+		super.broadcastChanges();
+		for (ContainerListener crafter : containerListeners) {
+            if(currentCookTime != furnace.currentCookTime) {
+				crafter.updateCraftingInventoryInfo(this, 0, furnace.currentCookTime);
+			}
+			if(currentBurnTime != furnace.currentBurnTime) {
+				crafter.updateCraftingInventoryInfo(this, 1, furnace.currentBurnTime);
+			}
+			if(itemCookTime != furnace.maxCookTime) {
+				crafter.updateCraftingInventoryInfo(this, 2, furnace.maxCookTime);
+			}
+			if(itemBurnTime != furnace.maxBurnTime) {
+				crafter.updateCraftingInventoryInfo(this, 3, furnace.maxBurnTime);
+			}
+		}
+
+		this.currentCookTime = furnace.currentCookTime;
+		this.currentBurnTime = furnace.currentBurnTime;
+		itemCookTime = furnace.maxCookTime;
+		itemBurnTime = furnace.maxBurnTime;
+	}
+
+	@Override
+	public void setData(int id, int value) {
+		if(id == 0) {
+			furnace.currentCookTime = value;
+		}
+		if(id == 1) {
+			furnace.currentBurnTime = value;
+		}
+		if(id == 2) {
+			furnace.maxCookTime = value;
+		}
+		if(id == 3) {
+			furnace.maxBurnTime = value;
+		}
+	}
+
+	@Override
+	public boolean stillValid(Player entityplayer) {
+		return furnace.stillValid(entityplayer);
+	}
+
+	/**
+	 *  0 Input
+	 *  1 Fuel
+	 *  2 Output
+	 *  3 - 29 Main Inventory (27x)
+	 * 30 - 38 Hotbar (9x)
+	 */
+
+	@Override
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= 0 && slot.index <= 3) return getSlots(slot.index, 1, false);
+
+		if(action == InventoryAction.MOVE_ALL) {
+			if(slot.index >= 3 && slot.index <= 30) {
+				// Main Inventory
+				return getSlots(3, 27, false);
+			}
+			if(slot.index >= 30 && slot.index <= 38) {
+				// Hotbar
+				return getSlots(30, 9, false);
+			}
+		}
+		if(slot.index >= 3 && slot.index <= 38) {
+			// Full Inventory
+			return getSlots(3, 36, false);
+		}
+		return null;
+	}
+
+	@Override
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= 3 && slot.index <= 39) {
+			// Full Inventory
+			if(action != InventoryAction.MOVE_ALL) {
+				if(target == 1) {
+					return getSlots(0, 1, false); // Into Ingredient Slot
+				}
+				if(target == 2) {
+					return getSlots(1, 1, false); // Into Fuel Slot
+				}
+			}
+			if(slot.index >= 3 && slot.index <= 29) {
+				// Main Inventory
+				return getSlots(30, 9, false); // Into Hotbar
+			}
+			if(slot.index >= 31 && slot.index <= 38) {
+				// Hotbar
+				return getSlots(3, 27, false); // Into Main Inventory
+			}
+		}
+		if(slot.index >= 0 && slot.index <= 2) {
+			if(slot.index == 2) {
+				// Output
+				return getSlots(3, 36, true);
+			}else {
+				// Input and Fuel
+				return getSlots(3, 36, false);
+			}
+		}
+
+		return null;
+	}
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/GuidebookMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/GuidebookMenu.java
new file mode 100644
index 000000000..e7132e011
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/GuidebookMenu.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.player.inventory.menu;
+
+import net.minecraft.core.InventoryAction;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.slot.Slot;
+
+import java.util.List;
+
+public class GuidebookMenu extends AbstractContainerMenu
+{
+
+	@Override
+	public boolean stillValid(final Player entityplayer)
+	{
+		return true;
+	}
+
+	@Override
+	public ItemStack clicked(InventoryAction action, int[] args, Player player) {
+		return null;
+	}
+
+	@Override
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+		return null;
+	}
+	
+	@Override
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+		return null;
+	}
+	
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayer.java b/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
similarity index 53%
rename from src/main/java/net/minecraft/core/player/inventory/ContainerPlayer.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
index a1deaa12d..9a8ae7979 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayer.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
@@ -1,37 +1,46 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.menu;
 
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.container.ResultContainer;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotArmor;
-import net.minecraft.core.player.inventory.slot.SlotCrafting;
+import net.minecraft.core.player.inventory.slot.ArmorSlot;
+import net.minecraft.core.player.inventory.slot.ResultSlot;
 
 import java.util.List;
 
-public class ContainerPlayer extends Container {
+public class InventoryMenu extends AbstractContainerMenu {
 
-	public ContainerPlayer(InventoryPlayer inventory) {
+	public CraftingContainer craftSlots;
+	public Container resultSlots;
+	public boolean active;
+	public Inventory inventory;
+
+	public InventoryMenu(Inventory inventory) {
 		this(inventory, true);
 	}
 
-	public ContainerPlayer(InventoryPlayer inventory, boolean isNotClientSide) {
-		craftMatrix = new InventoryCrafting(this, 2, 2);
-		craftResult = new InventoryCraftResult();
-		this.isNotClientSide = isNotClientSide;
-		playerInv = inventory;
-		addSlot(new SlotCrafting(inventory.player, craftMatrix, craftResult, 0, 144, 36));
+	public InventoryMenu(Inventory inventory, boolean active) {
+		craftSlots = new CraftingContainer(this, 2, 2);
+		resultSlots = new ResultContainer();
+		this.active = active;
+		this.inventory = inventory;
+		addSlot(new ResultSlot(inventory.player, craftSlots, resultSlots, 0, 144, 36));
 		
 		for (int i = 0; i < 2; i++) {
 			for (int j = 0; j < 2; j++) {
-				addSlot(new Slot(craftMatrix, j + i * 2, 88 + j * 18, 26 + i * 18));
+				addSlot(new Slot(craftSlots, j + i * 2, 88 + j * 18, 26 + i * 18));
 			}
 		}
 		
 		for (int i = 0; i < 4; i++) {
 			int j1 = i;
-			addSlot(new SlotArmor(this, inventory, inventory.getSizeInventory() - 1 - i, 8, 8 + i * 18, j1));
+			addSlot(new ArmorSlot(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, j1));
 		}
 		
 		for (int i = 0; i < 3; i++) {
@@ -44,22 +53,22 @@ public class ContainerPlayer extends Container {
 			addSlot(new Slot(inventory, i, 8 + i * 18, 142));
 		}
 
-		onCraftMatrixChanged(craftMatrix);
+		slotsChanged(craftSlots);
 	}
 
 	@Override
-	public void onCraftMatrixChanged(IInventory iinventory) {
-		craftResult.setInventorySlotContents(0, Registries.RECIPES.findMatchingRecipe(craftMatrix));
+	public void slotsChanged(Container iinventory) {
+		resultSlots.setItem(0, Registries.RECIPES.findMatchingRecipe(craftSlots));
 	}
 
 	@Override
-	public void onCraftGuiClosed(EntityPlayer player) {
+	public void onCraftGuiClosed(Player player) {
 		super.onCraftGuiClosed(player);
 		boolean insert = false;
 		for (int i = 0; i < 4; i++) {
-			ItemStack itemstack = craftMatrix.getStackInSlot(i);
+			ItemStack itemstack = craftSlots.getItem(i);
 			if(itemstack != null) {
-				craftMatrix.setInventorySlotContents(i, null);
+				craftSlots.setItem(i, null);
 				storeOrDropItem(player, itemstack);
 				insert = true;
 			}
@@ -70,7 +79,7 @@ public class ContainerPlayer extends Container {
 	}
 
 	@Override
-	public boolean isUsableByPlayer(EntityPlayer entityplayer) {
+	public boolean stillValid(Player entityplayer) {
 		return true;
 	}
 
@@ -83,30 +92,30 @@ public class ContainerPlayer extends Container {
 	 */
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id == 0) {
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index == 0) {
 			// Craft Result
 			return getSlots(0, 1, false);
 		}
-		if(slot.id >= 1 && slot.id <= 4) {
+		if(slot.index >= 1 && slot.index <= 4) {
     		// Crafting Grid
 			return getSlots(1, 4, false);
 		}
-		if(slot.id >= 5 && slot.id <= 8) {
+		if(slot.index >= 5 && slot.index <= 8) {
 			// Armor
 			return getSlots(5, 4, false);
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
-			if(slot.id >= 9 && slot.id <= 44) {
+			if(slot.index >= 9 && slot.index <= 44) {
 				// Full Inventory
 				return getSlots(9, 36, false);
 			}	
 		}else {
-			if(slot.id >= 9 && slot.id <= 35) {
+			if(slot.index >= 9 && slot.index <= 35) {
 				// Main Inventory
 				return getSlots(9, 27, false);
 			}
-			if(slot.id >= 36 && slot.id <= 44) {
+			if(slot.index >= 36 && slot.index <= 44) {
 				// Hotbar
 				return getSlots(36, 9, false);
 			}
@@ -115,8 +124,8 @@ public class ContainerPlayer extends Container {
 	}
 	
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id >= 9 && slot.id <= 44) {
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= 9 && slot.index <= 44) {
 			// Full Inventory
 			if(target == 1) {
 				return getSlots(1, 4, false); // Crafting
@@ -125,7 +134,7 @@ public class ContainerPlayer extends Container {
 				return getSlots(5, 4, false); // Armor
 			}
 			
-			if(slot.id < 36) {
+			if(slot.index < 36) {
 				// Main Inventory
 				return getSlots(36, 9, false); // Hotbar
 			}else {
@@ -133,7 +142,7 @@ public class ContainerPlayer extends Container {
 				return getSlots(9, 27, false); // Main Inventory
 			}
 		}else {
-			if(slot.id == 0) {
+			if(slot.index == 0) {
 				// Crafting Result
 				return getSlots(9, 36, true); // Full Inventory, Last First
 			}else {
@@ -143,9 +152,4 @@ public class ContainerPlayer extends Container {
 			
 		}
 	}
-
-	public InventoryCrafting craftMatrix;
-	public IInventory craftResult;
-	public boolean isNotClientSide;
-	public InventoryPlayer playerInv;
 }
